<?php
/**********************************************************************
***********************************************************************/

$page_security = 'SA_QUALITY_CHECK';
if (!@$_GET['popup'])
    $path_to_root = "..";
else	
    $path_to_root = "../..";

include_once($path_to_root . "/includes/session.inc");
include_once($path_to_root . "/includes/ui.inc");
include_once($path_to_root . "/purchasing/includes/ui/quality_checks_ui.inc");
include_once($path_to_root . "/purchasing/includes/db/quality_checks_db.inc");
include_once($path_to_root . "/purchasing/includes/db/direct_purchase_requisitions_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/items_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/items_units_db.inc"); 
include_once($path_to_root . "/admin/db/transactions_db.inc"); 
include_once($path_to_root . "/projects/includes/db/projects_db.inc"); 
include_once($path_to_root . "/includes/project_cost_functions.inc"); 
include_once($path_to_root . "/includes/db/inventory_db.inc"); 
include_once($path_to_root . "/includes/approval_functions.inc"); 

$js = '';
$js .= get_js_open_window(900, 500);
$js .= get_js_date_picker();

global $systypes_array;

if (isset($_GET['ApprovedID'])) {
    page(_($help_context = $systypes_array[ST_QUALITY_CHECK]), false, false, "", $js);
    
    $trans_no = $_GET['ApprovedID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('qck_messages');
    clear_session_variable('qck_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification_centered($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if (isset($_GET['BackedOrgID'])) {
    page(_($help_context = $systypes_array[ST_QUALITY_CHECK]), false, false, "", $js);
    
    $trans_no = $_GET['BackedOrgID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('qck_bo_messages');
    clear_session_variable('qck_bo_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if (isset($_GET['RejectedID'])) {
    page(_($help_context = $systypes_array[ST_QUALITY_CHECK]), false, false, "", $js);
    
    $trans_no = $_GET['RejectedID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('qck_rj_messages');
    clear_session_variable('qck_rj_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if ((isset($_GET['dpr_no']) && is_numeric($_GET['dpr_no'])) || (isset($_POST['dpr_no']) && is_numeric($_POST['dpr_no']))) {
    $_POST['dpr_no'] = isset($_GET['dpr_no']) ? $_GET['dpr_no'] : $_POST['dpr_no'];
    
    $header = get_direct_purchase_requisition_header_record($_POST['dpr_no']);
        if (is_array($header)) {
            if ($header['type'] != ST_DIRECT_PURCHASE_REQ) {
                page(_($help_context = ''), false, false, "", $js);
                display_error(("Invalid transaction type."));
                display_footer_exit();
            } 
        } else {
            page(_($help_context = ''), false, false, "", $js);
            display_error(("Could not find ".$systypes_array[ST_DIRECT_PURCHASE_REQ]." record #".$_POST['dpr_no']));
            display_footer_exit();
        }
    
    $page_title = _('New '.$systypes_array[ST_QUALITY_CHECK]);
    
} elseif ((isset($_GET['qck_no']) && is_numeric($_GET['qck_no'])) || (isset($_POST['qck_no']) && is_numeric($_POST['qck_no']))) {
    $_POST['qck_no'] = isset($_GET['qck_no']) ? $_GET['qck_no'] : $_POST['qck_no'];
    
    $header = get_quality_check_header_record($_POST['qck_no']);
        if (is_array($header)) {
            if ($header['type'] != ST_QUALITY_CHECK) {
                page(_($help_context = ''), false, false, "", $js);
                display_error(("Invalid transaction type."));
                display_footer_exit();
            } 
        } else {
            page(_($help_context = ''), false, false, "", $js);
            display_error(("Could not find ".$systypes_array[ST_QUALITY_CHECK]." record #".$_POST['qck_no']));
            display_footer_exit();
        }
        
    $_POST['dpr_no'] = $header['dpr_no'];
    $page_title = _('Modify '.$systypes_array[ST_QUALITY_CHECK]." #".$header['trans_no'] );
    
} else {
    page(_($help_context = ''), false, false, "", $js);
    display_error(("Could not find ".$systypes_array[ST_QUALITY_CHECK]));
    display_footer_exit();
}

page(_($help_context = $page_title), false, false, "", $js);

simple_page_mode(true);

if (isset($_POST['Approve_QCK'])) {
    $msg = save_quality_check($_POST['dpr_no'], $_POST['qck_no'], true);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['BACK_TO_ORIGINATOR_QCK'])) {
    $msg = back_to_originator_quality_check($_POST['dpr_no'], $_POST['qck_no']);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['REJECT_QCK'])) {
    $msg = reject_quality_check($_POST['dpr_no'], $_POST['qck_no']);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['Create_QCK'])) {        
    $msg = save_quality_check($_POST['dpr_no'], $_POST['qck_no']);
        if ($msg['success'] !== true) {
            if (isset($msg["focus_to"])) {
                set_focus($msg["focus_to"]);            
            }
            $return_hd_row = get_quality_check_header_record($_POST['qck_no']);
                if (! is_array($return_hd_row)) {
                    $qck_no = $_POST['qck_no'] = 0; 
                }
            display_error($msg['message']);
        } else {
            display_notification($msg['message']);
        }
}

if (isset($_POST['Add_DPR']) || isset($_POST['Update_DPR'])) {        
    $msg = handle_save_quality_check_line($_POST['dpr_no'], $_POST['qck_no'], $selected_id);
        if ($msg['success'] !== true) {
            if (isset($msg["focus_to"])) {
                set_focus($msg["focus_to"]);            
            }
            
            if ($_POST['qck_no'] > 0) {
                $header = get_quality_check_header_record($_POST['qck_no']);
                if (! is_array($header)) {
                    $_POST['qck_no'] = 0;
                }
            }
            display_error($msg['message']);
        } else {
            display_notification($msg['message']);
            clear_quality_check_details();
            $Mode = 'RESET';
        }
}

if ($Mode == 'Delete') {
    $msg = handle_delete_quality_check_line($_POST['qck_no'], $selected_id);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } else {
            display_notification($msg['message']);
            clear_quality_check_details();
            $Mode = 'RESET';
        }
}

if (isset($_POST['cancel']) || isset($_POST['Refresh']) || $Mode == 'RESET') {
    clear_quality_check_details();
    
    $Mode = 'RESET';
    $selected_id = -1;
}

global $Ajax;

start_form();

    if (isset($_POST['dpr_no']) && $_POST['dpr_no'] > 0) {
        hidden('dpr_no', $_POST['dpr_no']);
    } else {
        $_POST['dpr_no'] = 0;
    }   
        
    if (isset($_POST['qck_no']) && $_POST['qck_no'] > 0) {
        hidden('qck_no', $_POST['qck_no']);
    } else {
        $_POST['qck_no'] = 0;
    }  

    $Ajax->activate('_page_body');
    $Ajax->activate('All_details');
    div_start('All_details');
    
        $req_hd_row = display_direct_purchase_requisition_header_details($_POST['dpr_no'], $_POST['qck_no']);
        
        display_quality_check_header($_POST['qck_no'], $req_hd_row);

        display_quality_check_details($_POST['dpr_no'], $_POST['qck_no'], $selected_id, $Mode);

            $header = get_quality_check_header($_POST['qck_no']);
            if (is_array($header)) {
                submit_center_first('Create_QCK', _("Save ".$systypes_array[ST_QUALITY_CHECK]), '', 'default');  
                
                submit('Approve_QCK', _("Approve ".$systypes_array[ST_QUALITY_CHECK]), true, _("Release for Approval"), false, ICON_SUBMIT);
            
                submit_center_last('Refresh', 'Refresh', 'Refresh', false, ICON_SUBMIT);                br(2);

                start_table();
                    submit_center_first('REJECT_QCK', _("Reject ".$systypes_array[ST_QUALITY_CHECK]), '', true, ICON_DELETE);

                    submit('BACK_TO_ORIGINATOR_QCK', 'Back To Originator', true, 'Back To Originator', false, ICON_SUBMIT);
                end_table();
            } else {
                submit_center_first('Create_QCK', _("Create ".$systypes_array[ST_QUALITY_CHECK]), '', 'default');   
                
                submit('Refresh', 'Refresh', true, false, false, ICON_SUBMIT);
            }

    div_end();
    
end_form(2);
end_page(@$_GET['popup'], false, false);        

?>